package FDN::Adsl::Controller::Adhaccess;

use strict;
use warnings;
use base 'FDN::Adsl::Controller::Base';

use FDN::Web::Array;
use FDN::Web::Forms;

use FDN::Adsl::Basic;
use FDN::Adsl::New;
use FDN::Adsl::Utils;

__PACKAGE__->config->{'namespace'} = 'adsl/adhaccess';


sub _new :Path('new') {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $aid = $vars->{id};

	my $form = form_adhaccess($vars);

	if ( $vars->{'do'} ne 'yes' ) {
		renseigne_adhaccess($vars,$aid);
		$c->detach('Base','eject_page', [ affiche_form($form,$vars) ] );
	}
	if ( !check_transition($form,$vars) ) {
		$c->detach('Base','eject_page', [ affiche_form($form,$vars) ] );
	}
	my $prev = adhaccess_par_login($vars->{'login'});
	if ( $prev && $prev->{'ADHACCESS_ID'} != $aid ) {
		my $err = '<div class="error">Ce login est deja utilise.</div>'."\n\n";
		$c->detach('Base','eject_page', [ affiche_form($form,$vars).$err ] );
	}

	modifie_adhaccess($vars,$aid);
	my $from = $vars->{'from'};
	$c->detach('Base','back_from', [ $from ]);
}

sub liste :Local {
	my ( $self, $c ) = @_;

	$c->detach('Base','eject_error',["C'est idiot de vouloir lister des acces au tableau de bord en vrac"]);
}

sub view :Local {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $page;
	
	my $form = form_read('adsl/form/view.cfg','vadhaccess');
	if ( $vars->{'do'} ne 'yes' ) {
		$c->detach('Base','eject_page', [ affiche_form($form,$vars) ] );
	}
	if ( !check_transition($form,$vars) ) {
		$c->detach('Base','eject_page', [ affiche_form($form,$vars) ] );
	}

	my $adhid = $vars->{'adhid'};
	my $login = $vars->{'login'};

	if ( ! $adhid && ! $login ) {
		add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
		$c->detach('Base','eject_page', [ affiche_form($form,$vars) ] );
	}

	my $adh;
	if ( $adhid ) {
		$adh = adhaccess_par_id($adhid);
	} else {
		$adh = adhaccess_par_login($login);
	}

	if ( ! defined $adh ) {
		$c->detach('Base','eject_error',["Cet accs n'existe pas."]);
	}

	my $id = $adh->{'ADHACCESS_ID'};
	$page .= $self->small_table_1d($c,'adhaccess',$adh,"Un accs web ", {
		'Edition' => "/adsl/adhaccess/new?id=$id&from=adhaccess$id"
	});
	$c->detach('Base','eject_page', [ $page ] );
}

1;
