package FDN::Adsl::Controller::Adresse;

use strict;
use warnings;
use base 'FDN::Adsl::Controller::Base';

use FDN::Web::Array;
use FDN::Web::Forms;

use FDN::Adsl::Basic;
use FDN::Adsl::New;
use FDN::Adsl::Utils;

__PACKAGE__->config->{'namespace'} = 'adsl/adresse';


sub xnew :Path('new') {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $aid = $vars->{id};

	my $form = form_adresse($vars);
	if ( $vars->{'do'} ne 'yes' ) {
		renseigne_adresse($vars,$aid);
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}
	if ( !check_transition($form,$vars) ) {
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}
	modifie_adresse($vars,$aid);
	my $from = $vars->{'from'};
	$c->detach('Base','back_from', [$from]);
}

sub search :Local {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $page;

	if ( $vars->{'email'} ) {
		my $mail = $vars->{'email'};
		my $adrs = [ adresse_par_mail_like($mail) ];
		if ( @$adrs == 1 ) {
			my $aid = $adrs->[0]->{'ADRESSE_ID'};
			my $client = client_par_adresse_id($aid);
			if ( $client ) {
				my $cid = $client->{'CLIENT_ID'};
				$c->res->redirect("/adsl/client/view?cid=$cid&do=yes");
				return;
			}
		}
		if ( @$adrs ) {
			$page .= $self->large_table_2d($c, 'adresse', $adrs, "Adresses trouves");
		}
	}

	if ( $page ) {
		$c->detach('Base', 'eject_page', [ $page ] );
	}

	$c->detach('Base', 'eject_error', [ "Cette recherche ne donne rien" ] );
}

sub liste :Local {
	my ( $self, $c ) = @_;

	$c->detach('Base','eject_error',["C'est idiot de vouloir lister des adresses en vrac"]);
}

sub view :Local {
	my ( $self, $c, $iid ) = @_;

	my $vars = $c->req->params;
	my $page;

	my $form = form_read('adsl/form/view.cfg','vadresse');
	if ( $vars->{'do'} ne 'yes' ) {
		$page = affiche_form($form,$vars);
		$c->detach('Base','eject_page',[$page]);
		return;
		$c->detach('Base','eject_page', [ $page ]);
	}
	if ( !check_transition($form,$vars) ) {
		$page = affiche_form($form,$vars);
		$c->detach('Base','eject_page', [ $page ]);
	}

	my $aid = $vars->{'aid'};
	my $adresse = adresse_par_id($aid);

	if ( ! defined $adresse ) {
		$c->detach('Base','eject_error',["Cette adresse n'existe pas."]);
	}

        $page .= $self->small_table_1d($c,'adresse',$adresse,"Une adresse", {
                'Edition' => "/adsl/adresse/new?id=$aid&from=adresse$aid"
        });

	$c->detach('Base','eject_page', [ $page ]);
}

1;
