package FDN::Adsl::Controller::Deploiement;

use strict;
use warnings;
use base 'FDN::Adsl::Controller::Base';

use FDN::Web::Array;
use FDN::Web::Forms;

use FDN::Adsl::Basic;
use FDN::Adsl::Utils;
use FDN::Adsl::New;

__PACKAGE__->config->{'namespace'} = 'adsl/deploiement';


### sub _new :Path('new') {
### 	my ( $self, $c ) = @_;
### 
### 	my $vars = $c->req->params;
### 	my $creance;
### 
### 	my $form = form_creance($vars);
### 	my $crid = $vars->{'id'};
### 
### 	if ( $vars->{'do'} ne 'yes' ) {
### 		renseigne_creance($vars,$crid);
### 		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
### 	}
### 	if ( !check_transition($form,$vars) ) {
### 		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
### 	}
### 	$crid = modifie_creance($vars,$crid);
### 
### 	my $from = $vars->{'from'};
### 	$from //= 'creance'.$crid;
### 	$c->detach('Base','back_from', [$from]);
### }
### 
### sub liste :Local {
### 	my ( $self, $c ) = @_;
### 
### 	my $vars = $c->req->params;
### 
### 	if ( $vars->{'state'} ) {
### 		my $state = $vars->{'state'};
### 		$c->log->info("Liste des creances dont l'etat est '$state'");
### 		my @crs   = creance_par_etat($state);
### 		@crs = sort { $a->{CREANCE_ID} <=> $b->{CREANCE_ID} } @crs;
### 		my $page  = $self->large_table_2d_pognon($c,'creance','CREANCE',\@crs,"Liste des crances etat=$state");
### 		$c->detach('Base','eject_page',[$page]);
### 	}
### 		
### 	$c->detach('Base','eject_error',["C'est idiot de vouloir lister des crances en vrac"]);
### }

sub view :Local {
	my ( $self, $c ) = @_;

	my $vars = $c->req->params;
	my $page;

	my $form = form_read('adsl/form/view.cfg','vdeploiement');
	if ( $vars->{'do'} ne 'yes' ) {
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}
	if ( !check_transition($form,$vars) ) {
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}

	my $depl;
	my $did;
	my $num;
	if ( defined $vars->{'did'} && $vars->{'did'} ) {
		$did  = $vars->{'did'};
		$depl = deploiement_par_id($did);
		$num = $depl->{'DEPLOIEMENT_NUM'};
	} elsif ( defined $vars->{'deplnum'} && $vars->{'deplnum'} ) {
		$num = $vars->{'deplnum'};
		$depl = deploiement_par_num($num);
		$did = $depl->{'DEPLOIEMENT_ID'};
	} else {
		add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
		$c->detach('Base','eject_page',[affiche_form($form,$vars)]);
	}

	if ( ! defined $depl ) {
		$c->detach('Base','eject_error', [ "Ce dploiement n'existe pas" ] );
	}

	$page = $self->small_table_1d($c, 'deploiement', $depl);

	$c->detach('Base','eject_page',[ $page ]);
}

1;
