package FDN::Adsl::Controller::Root;

use strict;
use warnings;
use base 'Catalyst::Controller';

use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Common::Utils;
use FDN::Web::TemplateParse;

__PACKAGE__->config->{'namespace'} = '';

sub auto :Private {
	my ( $self, $c ) = @_;
	logger_purge();
	return 1;
}

sub default :Local {
	my ( $self, $c ) = @_;
	$c->res->body("<html><body>Cette page n'existe pas</body></html>");
	$c->res->status(404);
}

sub _index :Path('') :Args(0) {
	my ( $self, $c ) = @_;
	$self->show_full($c, 'menu.tt', {});
}

sub index :Local :Args(0) {
	my ( $self, $c ) = @_;
	$self->show_full($c, 'menu.tt', {});
}

sub show_full :Private {
	my ( $self, $c, $tpl, $vars ) = @_;
	my $page = $c->forward('TT', 'partial', [ $tpl, $vars ]);
	$c->detach('TT', 'final', [ 'base2.tt', { PAGE => $page } ]);
}

sub changelog :Local :Args(0) {
	my ( $self, $c ) = @_;
	my $change = slurp_file('/var/www/private/changelog');
	$c->detach('Base', 'eject_page', [ '<pre>'.$change.'</pre>' ] );
}
	

1;
