package FDN::Adsl::Controller::Stats;

use strict;
use warnings;
use base 'FDN::Adsl::Controller::Base';

use DateTime;
use DateTime::Duration;
### 
### use FDN::Common::Config;
### use FDN::Web::Array;
### use FDN::Web::Forms;
### 
### use FDN::Adsl::Basic;
### use FDN::Adsl::Infos;
### use FDN::Adsl::Liste;
### use FDN::Adsl::New;
### use FDN::Adsl::Utils;
### use FDN::Adsl::Prelevemt;
### use FDN::Adsl::Purge;
### use FDN::Adsl::Numadh;
### use FDN::Adsl::Ag;
### use FDN::Adsl::Radius;
use FDN::Adsl::Stats;

__PACKAGE__->config->{'namespace'} = 'adsl/stats';

sub daily :Path('') {
	my ( $self, $c, $date ) = @_;
	my ( $now, $month, $year );
	if ( $date && $date =~ /^(\d{4})-(\d\d)-(\d\d)$/ ) {
		$now = DateTime->new(year => $1, month => $2, day => $3);
	} else {
		$now = DateTime->now;
	}
	$date = $now->ymd;
	if ( $date gt DateTime->now->ymd ) {
		$c->detach('Base','eject_error',["Moi, je calcule des stats dans le pass. Ou le prsent si je suis de bonne humeur. Pour les prdictions, voir avec Mme soleil."]);
	}
	if ( $date lt "2000-01-01" ) {
		$c->detach('Base','eject_error',["En ces temps-l, Internet tait jeune et beau, et les dinosaures gambadaient en ses vertes prairies insouciantes...<br/>\n".
					"Et on n'embtait pas les gens avec des stats  la con.<br/>\n".
					"Ah mais."]);
	}
	$month = $now->clone->subtract_duration(DateTime::Duration->new(months => 1))->ymd;
	$year  = $now->clone->subtract_duration(DateTime::Duration->new(years  => 1))->ymd;

	my $statsD = retrieve_stats($date);
	if ( ref($statsD) ne 'HASH' ) {
		$c->detach('Base','eject_error',["Pas pu produire les stats pour '$date'. Probleme de date ?"]);
	}
	my $statsM = retrieve_stats($month);
	if ( ref($statsM) ne 'HASH' ) {
		$c->detach('Base','eject_error',["Pas pu produire les stats pour '$month'. Probleme de date ?"]);
	}
	my $statsY = retrieve_stats($year);
	if ( ref($statsY) ne 'HASH' ) {
		$c->detach('Base','eject_error',["Pas pu produire les stats pour '$year'. Probleme de date ?"]);
	}

	my $vars = {
		date => $date,
		month => $month,
		year => $year,
		stats => [ 'nbadh', 'nbadh_abonne', 'nbadsl', 'nbadsl_adh', 'nbadsl_coll', 'nbadsl_nerim', 'nbadsl_liazo', 'nbadsl_adsl', 'nbadsl_vdsl', 'nbftth', 'nbftth_adh', 'nbftth_coll', 'nbftth_axione', 'nbvpn' ],
		statsD => $statsD,
		statsM => $statsM,
		statsY => $statsY
	};
use Data::Dumper;
	$c->log->info(Dumper($vars));
	my $page = $c->forward('TT','partial',[ 'daily_stat.tt', $vars ]);
	$c->detach('Base','eject_page',[ $page ]);
}

1;
