package FDN::Adsl::View::TP;

use strict;
use warnings;
use base 'Catalyst::View';

use FDN::Common::Config;
use FDN::Web::TemplateParse;


sub partial {
	my ( $self, $c, $tpl, $vars ) = @_;

	my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
	my $file = $dir.'/'.$tpl;
	if ( ! -f $file ) {
		$c->log->error('File not found: '.$file);
		return 'File not found';
	}
	my $page = remplace($dir.'/'.$tpl,$vars,1);
	return $page;
}

sub final {
	my ( $self, $c, $tpl, $vars ) = @_;

	my $res = $c->forward($self, 'partial', [ $tpl, $vars ]);
	$c->res->body($res);
	$c->res->content_type('text/html; charset=ISO-8859-1');
	$c->res->headers->header('Expires'=>'-1');
}

1;

