package FDN::Adsl::View::TT;

use strict;
use warnings;
use base 'Catalyst::View::TT';
use Encode;

sub partial {
	my ( $self, $c, $tpl, $vars ) = @_;
	return '' if !defined $tpl;
	my $res = $c->view('TT')->render($c, $tpl, $vars);
	if (UNIVERSAL::isa($res, 'Template::Exception')) {
		my $error = qq/Couldn't render template "$res"/;
		$c->log->error($error);
		$c->error($error);
		return '';
	}

	return $res;
}

sub final {
	my ( $self, $c, $tpl, $vars ) = @_;

	if ( $vars->{'encoding'} eq 'latin1' ) {
		$c->log->info("Decoding from latin1");
		$vars->{'PAGE'} = encode('utf8',decode('latin1',$vars->{'PAGE'}));
	} else {
		$c->log->info("Page is utf8");
	}

	my $res = $c->forward($self ,'partial', [$tpl,$vars]);
	$c->response->body($res);
	$c->response->content_type('text/html; charset=utf-8');
	$c->response->headers->header( 'Expires' => '-1' );
}

sub ajax {
	my ( $self, $c, $vars ) = @_;

	if ( $vars->{'encoding'} eq 'latin1' ) {
		$c->log->info("Decoding from latin1");
		$vars->{'PAGE'} = encode('utf8',decode('latin1',$vars->{'PAGE'}));
	} else {
		$c->log->info("Page is utf8");
	}

$c->log->info("Response in AJAX is ".$vars->{'PAGE'});
	$c->response->body($vars->{'PAGE'});
	$c->response->content_type('text/html; charset=utf-8');
	$c->response->headers->header( 'Expires' => '-1' );
}

1;


